// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "GspellTextView")]
    pub struct TextView(Object<ffi::GspellTextView, ffi::GspellTextViewClass>);

    match fn {
        type_ => || ffi::gspell_text_view_get_type(),
    }
}

impl TextView {
    pub const NONE: Option<&'static TextView> = None;

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`TextView`] objects.
    ///
    /// This method returns an instance of [`TextViewBuilder`](crate::builders::TextViewBuilder) which can be used to create [`TextView`] objects.
    pub fn builder() -> TextViewBuilder {
        TextViewBuilder::new()
    }

    #[doc(alias = "gspell_text_view_get_from_gtk_text_view")]
    #[doc(alias = "get_from_gtk_text_view")]
    pub fn from_gtk_text_view(gtk_view: &impl IsA<gtk::TextView>) -> Option<TextView> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::gspell_text_view_get_from_gtk_text_view(
                gtk_view.as_ref().to_glib_none().0,
            ))
        }
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`TextView`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct TextViewBuilder {
    builder: glib::object::ObjectBuilder<'static, TextView>,
}

impl TextViewBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn enable_language_menu(self, enable_language_menu: bool) -> Self {
        Self {
            builder: self
                .builder
                .property("enable-language-menu", enable_language_menu),
        }
    }

    pub fn inline_spell_checking(self, inline_spell_checking: bool) -> Self {
        Self {
            builder: self
                .builder
                .property("inline-spell-checking", inline_spell_checking),
        }
    }

    pub fn view(self, view: &impl IsA<gtk::TextView>) -> Self {
        Self {
            builder: self.builder.property("view", view.clone().upcast()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`TextView`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> TextView {
        self.builder.build()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::TextView>> Sealed for T {}
}

pub trait TextViewExt: IsA<TextView> + sealed::Sealed + 'static {
    #[doc(alias = "gspell_text_view_basic_setup")]
    fn basic_setup(&self) {
        unsafe {
            ffi::gspell_text_view_basic_setup(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "gspell_text_view_get_enable_language_menu")]
    #[doc(alias = "get_enable_language_menu")]
    fn enables_language_menu(&self) -> bool {
        unsafe {
            from_glib(ffi::gspell_text_view_get_enable_language_menu(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_text_view_get_inline_spell_checking")]
    #[doc(alias = "get_inline_spell_checking")]
    fn is_inline_spell_checking(&self) -> bool {
        unsafe {
            from_glib(ffi::gspell_text_view_get_inline_spell_checking(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_text_view_get_view")]
    #[doc(alias = "get_view")]
    fn view(&self) -> Option<gtk::TextView> {
        unsafe {
            from_glib_none(ffi::gspell_text_view_get_view(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "gspell_text_view_set_enable_language_menu")]
    fn set_enable_language_menu(&self, enable_language_menu: bool) {
        unsafe {
            ffi::gspell_text_view_set_enable_language_menu(
                self.as_ref().to_glib_none().0,
                enable_language_menu.into_glib(),
            );
        }
    }

    #[doc(alias = "gspell_text_view_set_inline_spell_checking")]
    fn set_inline_spell_checking(&self, enable: bool) {
        unsafe {
            ffi::gspell_text_view_set_inline_spell_checking(
                self.as_ref().to_glib_none().0,
                enable.into_glib(),
            );
        }
    }

    #[doc(alias = "enable-language-menu")]
    fn connect_enable_language_menu_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_enable_language_menu_trampoline<
            P: IsA<TextView>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::GspellTextView,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TextView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::enable-language-menu\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_enable_language_menu_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "inline-spell-checking")]
    fn connect_inline_spell_checking_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_inline_spell_checking_trampoline<
            P: IsA<TextView>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::GspellTextView,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TextView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::inline-spell-checking\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_inline_spell_checking_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<TextView>> TextViewExt for O {}

impl fmt::Display for TextView {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("TextView")
    }
}
